package com.casic.dcms.view.upload;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityBusinessCaseBinding;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.utils.PictureSelectorHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ViewGroupKit;
import com.casic.dcms.utils.callback.ISelectorListener;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.map.ArcGISMapActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.casic.dcms.vm.UploadViewModel;
import com.luck.picture.lib.entity.LocalMedia;
import com.pengxh.androidx.lite.adapter.EditableImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.kit.ContextKit;
import com.pengxh.androidx.lite.kit.IntKit;
import com.pengxh.androidx.lite.kit.StringKit;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.LoadingDialog;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class BusinessCaseActivity extends AndroidxBaseActivity<ActivityBusinessCaseBinding> {

    private final Context context = BusinessCaseActivity.this;
    private final ArrayList<String> realPaths = new ArrayList<>();//真实图片路径
    private final List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private final Queue<LocalMedia> uploadQueue = new LinkedList<>(); // 用于存储待上传的图片
    private boolean isUploading = false; // 标记是否正在上传图片
    private UploadViewModel uploadViewModel;
    private CaseViewModel caseViewModel;
    private EditableImageAdapter imageAdapter;
    private String gridId, shopID;

    private final ActivityResultLauncher<Intent> packageCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");
                String shopName = data.getStringExtra("shopName");
                shopID = data.getStringExtra("shopID");

                binding.longitudeView.setText(String.valueOf(longitude));
                binding.latitudeView.setText(String.valueOf(latitude));
                binding.communityNameView.setText(community);
                binding.shopView.setText(shopName);
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        ViewGroupKit.initImmersionBar(binding.rootView, this, true, R.color.white);

        binding.titleBarLayout.titleView.setText("三包上报");
        binding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        caseViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    LoadingDialog.show(BusinessCaseActivity.this, "案卷提交中，请稍后...");
                } else if (loadState == LoadState.Success) {
                    LoadingDialog.dismiss();
                    StringKit.show(context, "案卷提交成功");
                    finish();
                } else {
                    StringKit.show(context, "提交失败，请重试");
                    LoadingDialog.dismiss();
                }
            }
        });

        uploadViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    StringKit.show(BusinessCaseActivity.this, "上传中，请稍后...");
                }
            }
        });
    }

    @Override
    public void initOnCreate(@Nullable Bundle savedInstanceState) {
        uploadViewModel = new ViewModelProvider(this).get(UploadViewModel.class);
        uploadViewModel.imageModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                isUploading = false;
                if (resultBean.getCode() == 200) {
                    String url = resultBean.getData();
                    imageList.add(url);
                    int oldSize = realPaths.size();
                    realPaths.add(StringHelper.appendCompleteURL(url));
                    imageAdapter.notifyItemRangeChanged(oldSize, 1);
                    startUploadNextImage(); // 上传下一张图片
                } else {
                    StringKit.show(context, "图片上传失败，请重试");
                }
            }
        });

        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);

        int width = ContextKit.getScreenWidth(this) - IntKit.dp2px(this, 20);
        imageAdapter = new EditableImageAdapter(this, realPaths, width, 2, 3);
        binding.addImageRecyclerView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        binding.shopLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, ArcGISMapActivity.class);
                intent.putExtra("type", "三包上报");
                packageCaseLauncher.launch(intent);
            }
        });

        /**
         * 图片九宫格事件处理
         * */
        imageAdapter.setOnItemClickListener(new EditableImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                PictureSelectorHelper.selectPicture(context, 2, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        uploadQueue.addAll(result); // 将选中的图片加入队列
                        startUploadNextImage();
                    }
                });
            }

            @Override
            public void onItemClick(int position) {
                if (realPaths.get(position).isEmpty()) {
                    StringKit.show(context, "图片加载失败，无法查看大图");
                } else {
                    ContextKit.navigatePageTo(context, BigImageActivity.class, position, realPaths);
                }
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                realPaths.remove(position);
                imageAdapter.notifyItemRemoved(position);
                imageAdapter.notifyItemRangeChanged(position, realPaths.size() - position);
            }
        });

        binding.submitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                submitCase();
            }
        });
    }

    private void startUploadNextImage() {
        if (isUploading || uploadQueue.isEmpty()) {
            return;
        }

        isUploading = true;
        LocalMedia media = uploadQueue.poll();
        if (media != null) {
            uploadViewModel.uploadImage(this, new File(media.getRealPath()));
        } else {
            isUploading = false;
        }
    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = binding.longitudeView.getText().toString();
        String latitude = binding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            StringKit.show(this, "经纬度异常，请重新选择位置");
            return;
        }
        String shopKeeper = binding.shopKeeperView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(shopKeeper)) {
            StringKit.show(this, "店主名还未填写");
            return;
        }
        String phoneNumber = binding.phoneNumberView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(phoneNumber)) {
            StringKit.show(this, "电话号码还未填写");
            return;
        }
        if (!StringHelper.isPhoneNumber(phoneNumber)) {
            StringKit.show(this, "电话号码格式不对");
            return;
        }
        String fieldIntro = binding.caseLocationView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(fieldIntro)) {
            StringKit.show(this, "案卷地点还未填写");
            return;
        }
        String description = binding.caseDetailEditView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(description)) {
            StringKit.show(this, "案卷情况还未填写");
            return;
        }
        if (imageAdapter.getItemCount() < 1) {
            StringKit.show(this, "至少上传一张图片");
            return;
        }

        caseViewModel.submitShopCase(this, "0", "0", longitude, latitude,
                "2", "1",
                gridId.substring(0, 6),
                gridId.substring(0, 9),
                gridId.substring(0, 12),
                gridId, description, fieldIntro,
                StringHelper.reformatURL(imageList),
                0, 0, shopID, shopKeeper, phoneNumber);
    }
}
